# Copyright 2022, TATA Consultancy Services. All rights reserved.
import tensorflow
from tensorflow.keras.layers import Input, Dense
from tensorflow.keras.layers import Conv2D, Conv1D
from tensorflow.keras.layers import Flatten
from tensorflow.keras.layers import MaxPooling2D, MaxPooling1D, GlobalAveragePooling2D, GlobalAveragePooling1D
from tensorflow.keras.layers import Activation, BatchNormalization, Dropout
from tensorflow.keras.layers import concatenate, Multiply, TimeDistributed, LSTM
from tensorflow.keras.models import Model


def CNNet(nrw, ncl, num_classes):
    # =========
    model = tensorflow.keras.models.Sequential([
            tensorflow.keras.layers.Conv2D(16, (3, 3), activation='relu', input_shape=(nrw, ncl, 1)),#filter 16
            tensorflow.keras.layers.BatchNormalization(),
            tensorflow.keras.layers.MaxPooling2D(2, 2),
            tensorflow.keras.layers.Dropout(0.45),
            #
            tensorflow.keras.layers.Conv2D(32, (3, 3), activation='relu'),
            tensorflow.keras.layers.BatchNormalization(),
            tensorflow.keras.layers.MaxPooling2D(2, 2),
            tensorflow.keras.layers.Dropout(0.45),
            #
            tensorflow.keras.layers.Conv2D(64, (3, 3), activation='relu'),
            tensorflow.keras.layers.BatchNormalization(),
            tensorflow.keras.layers.MaxPooling2D(2, 2),
            tensorflow.keras.layers.Dropout(0.4),
            #
            tensorflow.keras.layers.Conv2D(128, (3, 3), activation='relu'),
            tensorflow.keras.layers.BatchNormalization(),
            tensorflow.keras.layers.MaxPooling2D(2, 2),
            tensorflow.keras.layers.Dropout(0.4),
            #
            tensorflow.keras.layers.Flatten(),
            tensorflow.keras.layers.Dense(128, activation='relu'),
            tensorflow.keras.layers.Dense(32, activation='relu'),
            tensorflow.keras.layers.Dense(1, activation='sigmoid')#VS3
    ])


    # #from tensorflow.keras.utils import plot_model
    # print(model.summary())
    # import pydot
    # print(pydot.__version__)
    # #plot_model(model, to_file='/home/varsha/2022_Works/PNC2022/model/multiple_inputs.png',show_shapes=True)

    return model



