from runSpringerSegmentationAlgorithm import runSpringerSegmentationAlgorithm
from scipy.io import loadmat
import scipy
from Resampling_function import Resampling
from default_Springer_HSMM_options import default_Springer_HSMM_options
import numpy as np
import matplotlib
# matplotlib.use('TkAgg')
import matplotlib.pyplot as plt
import numpy as np
# import soundfile
import os


# # Find patient data files.
# def find_patient_files(data_folder):
#     # Find patient files.
#     filenames = list()
#     for f in sorted(os.listdir(data_folder)):
#         root, extension = os.path.splitext(f)
#         if not root.startswith('.') and extension=='.wav':
#             filename = os.path.join(data_folder, f)
#             filenames.append(filename)
#     # To help with debugging, sort numerically if the filenames are integers.
#     roots = [os.path.split(filename)[1][:-4] for filename in filenames]
#     # if all(is_integer(root) for root in roots):
#     #     filenames = sorted(filenames, key=lambda filename: int(os.path.split(filename)[1][:-4]))
#     return filenames


def load_wav_file(filename):
    frequency, recording = scipy.io.wavfile.read(filename)
    return recording, frequency


def get_norm(signal1):
    tim = ((1 - (-1)) * ((signal1 - np.min(signal1)) / (np.max(signal1) - np.min(signal1)))) + (-1)
    return tim

#filenames = find_patient_files('/workspace/data/PNC2022_data/circordigiscope1.0.3/training_data')

def pcg_segmentation(PCG_resampled):

    # Springer_B_matrix = 0
    # Springer_pi_vector = 0
    # Springer_total_obs_distribution = 0
    Springer_B_matrix = loadmat('Springer_B_matrix.mat')
    Springer_pi_vector = loadmat('Springer_pi_vector.mat')
    Springer_total_obs_distribution = loadmat('Springer_total_obs_distribution.mat')
    Springer_B_matrix = Springer_B_matrix['Springer_B_matrix']
    Springer_pi_vector = Springer_pi_vector['Springer_pi_vector']
    Springer_total_obs_distribution = Springer_total_obs_distribution['Springer_total_obs_distribution']

    springer_options   = default_Springer_HSMM_options()

    # cur_data = current_recordings_location.astype(np.float32)
    # PCG = get_norm(cur_data)
    # addr = ('/home/tcs1435818/Python_projects/matlab2python/sample2016_trimmed_conversion/sample2016_trimmed_python_converted/samplePCG/absent/2530_AV.wav')
    # [PCG,Fs1]         = soundfile.read(addr)

    # PCG_resampled      = Resampling(PCG,springer_options['audio_Fs'],Fs1) # resample to springer_options.audio_Fs (1000 Hz)
    #PCG_resampled  = scipy.signal.resample_poly(PCG, int(springer_options['audio_Fs']), Fs1) # resample to springer_options.audio_Fs (1000 Hz)

    # ind_resampled = np.linspace(0, 1, len(PCG_resampled), endpoint=False)
    # # plt.plot(ind_resampled, PCG_resampled)
    # ind = np.linspace(0, 1, len(PCG_resampled), endpoint=False)
    # ind = np.linspace(0, len(PCG_resampled)/Fs1,len(PCG_resampled), endpoint=False)
    #
    # # plt.plot(ind,PCG)
    # # plt.savefig("mygraph.png")
    #
    # #plt.show()

    ## Running runSpringerSegmentationAlgorithm.m to obtain the assigned_states
    assigned_states, heartRate = runSpringerSegmentationAlgorithm(PCG_resampled, springer_options['audio_Fs'], Springer_B_matrix, Springer_pi_vector, Springer_total_obs_distribution) # obtain the locations for S1, systole, s2 and diastole
    # ind = np.linspace(0, len(PCG_resampled) / Fs1, len(PCG_resampled), endpoint=False)
    # 
    # assigned_states = assigned_states + 1
    # row_ind = 0
    # time_matrix = np.zeros((len(ind), 2))
    # ind_final = np.zeros((len(ind), 1), dtype=int)
    # for i in np.arange(0, len(ind)-1).reshape(-1):
    #     if i == 0:
    #         time_matrix[row_ind, 0] = ind[i]
    #         ind_final[row_ind, 0] = assigned_states[i]
    #     if (assigned_states[i] != assigned_states[i + 1]):
    #         time_matrix[row_ind, 1] = ind[i + 1]
    #         row_ind = row_ind + 1
    #         ind_final[row_ind, 0] = assigned_states[i + 1]
    #         time_matrix[row_ind, 0] = ind[i + 1]
    #         temp = ind[i+1]
    #     if (i == len(ind) - 2):
    #         time_matrix[row_ind, 1] = ind[i+1]
    # 
    # #loc_matrix_gold = np.hstack((ind.reshape([-1,1]), assigned_states))
    # loc_matrix = np.hstack((time_matrix, ind_final))
    # loc_matrix1 = loc_matrix[0:np.where(loc_matrix[:, 1] == 0)[0][0]]
    # 
    # # np.savetxt('/home/tcs1435818/Python_projects/matlab2python/sample2016_trimmed_conversion/sample2016_trimmed_python_converted/samplePCG/file.csv', assigned_states, delimiter=',')
    # # plt.plot(ind,PCG_resampled*4, label = "pcg")
    # # plt.plot(ind, assigned_states, label = "states")
    # # plt.savefig("PCG.png")
    # 
    # # plt.show()
    # #print('end')

    # return loc_matrix1

    return assigned_states, heartRate



