#!/usr/bin/env python
seed = 42
env={'PYTHONHASHSEED': seed}

import random
random.seed(seed)
#
import numpy as np, scipy as sp, pandas as pd, os, sys, joblib, pickle
np.random.seed(seed)
import matplotlib.pyplot as plt

from scipy.signal import resample_poly
from scipy.signal import spectrogram
from scipy.signal.windows import hann
from helper_code import *
from main_segmentation import pcg_segmentation
# from default_Springer_HSMM_options import default_Springer_HSMM_options

def remove_noisy_incomplete_cycle(sound_loc):
    arr = sound_loc[:, 2]
    pattern = [1, 2, 3, 4]
    # ---------------------------------
    pattern_length = len(pattern)
    potential_patterns = np.where(arr == pattern[0])[0]
    # ---------------------------------
    pattern_start_index = []
    for p in potential_patterns:
        check = arr[p:p + pattern_length]
        if np.all(check == pattern):
            pattern_start_index.append(p)

    pattern_start_index = np.array(pattern_start_index)
    # ---------------------------------
    a1 = np.zeros((len(pattern_start_index), pattern_length))
    a1 = a1.astype(int)
    for i in range(pattern_length):
        a1[:, i] = pattern_start_index + i
    index = np.hstack((a1))
    # ---------------------------------
    sound_loc_cleaned = sound_loc[index]

    return sound_loc_cleaned


def Moving_average(arr,window_size):
    # arr = [1, 2, 3, 7, 9]
    # window_size = 3

    i = 0
    # Initialize an empty list to store moving averages
    moving_averages = []

    # Loop through the array t o
    # consider every window of size 3
    while i < len(arr) - window_size + 1:
        # Calculate the average of current window
        window_average = round(np.sum(arr[i:i + window_size]) / window_size, 2)

        # Store the average of current
        # window in moving average list
        moving_averages.append(window_average)

        # Shift window to right by one position
        i += 1

    #print(moving_averages)
    return moving_averages

def get_norm(signal1):
    tim = ((1 - (-1)) * ((signal1 - np.min(signal1)) / (np.max(signal1) - np.min(signal1)))) + (-1)
    return tim

#filename ='/home/varsha/2022_Works/PNC2022/1_Official_phase/the-circor-digiscope-phonocardiogram-dataset-1.0.3/training_data/49572_TV.wav'#'# 49630_AV.wav: present, 49572_TV

# filelist = ['50206_MV', '50049_PV', '84852_TV', '49630_MV', '50332_MV', '50075_MV', '85287_TV', '84991_AV', '85192_MV', '85219_PV']#['69174_PV','40840_TV',
# #filelist = ['50332_MV', '50075_MV']
# percent_val = [20, 20, 70, 70, 95,95, 55,55,0,0]
# for file in range(len(filelist)):
#

def test_get_clean_complete_states(raw_pcg_norm_resamp, raw_pcg_resamp, fs, num_of_segments_in_order):

    # #f = filelist[f]
    # filename ='/home/varsha/2022_Works/PNC2022/1_Official_phase/the-circor-digiscope-phonocardiogram-dataset-1.0.3/training_data/'+filelist[file] +'.wav'#'# 49630_AV.wav: present, 49572_TV
    # print(os.path.basename(filename), percent_val[file])
    # if os.path.basename(filename) != '50075_MV.wav':
    #     continue;
    # raw_pcg, frequency = load_wav_file(filename)
    #
    # springer_options   = default_Springer_HSMM_options()
    # raw_pcg = raw_pcg.astype(np.float32)
    # raw_pcg_norm = get_norm(raw_pcg)
    # fs = int(springer_options['audio_Fs'])
    # raw_pcg_norm_resamp = resample_poly(raw_pcg_norm, fs, frequency)
    # raw_pcg_resamp = resample_poly(raw_pcg, fs, frequency)
    sound_states, heartRate = pcg_segmentation(raw_pcg_norm_resamp)
    original_sound_states = sound_states
    #current_recordings = current_recordings[0: int(13*frequency)]

    # 1024, 512
    slowest_possible_hr = 60
    cardiac_cycle =(60/slowest_possible_hr) * fs#117#49630_AV:77
    nperseg = int(fs/10)#512
    overlap = int(0.5 * nperseg)# 0.9

    f, t, Sxx = spectrogram(raw_pcg_resamp, fs, mode='magnitude', window=hann(nperseg, sym=False),
                            return_onesided=True, noverlap=overlap, nperseg=nperseg)


    # # #=== plot spectrogram
    # Sxx_norm = ((255 - (0)) * ((Sxx - np.min(Sxx)) / (np.max(Sxx) - np.min(Sxx)))) + (0)
    # Sxx_norm = np.array(Sxx_norm, dtype = np.uint8)
    # Sxx_plot = np.array(Sxx, dtype=np.uint8)
    #
    # plt.pcolormesh(t, f, Sxx_plot, shading='gouraud', cmap='Greys_r', vmin=20, vmax=80, alpha=1)  # Greys_r
    # plt.ylabel('Frequency [Hz]')
    # plt.xlabel('Time [sec]')
    # plt.title(os.path.basename(filename).split(".")[0] +'_'+str(percent_val[file]))
    # plt.savefig('/home/varsha/2022_Works/PNC2022/1_Official_phase/pnc_2022_newdata_run3_with_segmentation/'+os.path.basename(filename).split(".")[0]+'.png', bbox_inches='tight')
    # # plt.show()
    # plt.close()

    #--------------

    sum_spec = np.sum(Sxx[int(np.where(f==200)[0]):len(f)],axis=0)
    cardiac_cycle_spec = cardiac_cycle * (Sxx.shape[1]/len(raw_pcg_norm_resamp))

    ma_win = int(cardiac_cycle_spec/4)
    ma = Moving_average(sum_spec, ma_win)
    ma = np.array(ma)
    #ma =  ((1 - (0)) * ((ma - np.min(ma)) / (np.max(ma) - np.min(ma)))) + (0)
    # print('percentile', np.percentile(ma, 85))
    # print('percentile 50*1.7', np.percentile(ma, 50)*1.7)
    # print('percentile 50*2', np.percentile(ma, 50)*2)

    percentile_value = 50
    scaling_factor = 3#3.4

    threshold = min(np.percentile(ma, percentile_value) * scaling_factor, 1800)
    #sound_states_for_complete_cycle = np.empty([1,3])
    # & sound_states_for_complete_cycle.shape[0] >=8
    clean_signal_ok = 0
    while (clean_signal_ok == 0):

        print(threshold)

        # for per in [50,60,70,80,90]:
        #     print(per, np.percentile(ma, per))

        # plt.plot(ma, 'ro')
        # plt.plot(np.repeat(threshold, len(ma)))
        # plt.title(os.path.basename(filename).split(".")[0] +'_'+str(percent_val[file]))
        # plt.savefig('/home/varsha/2022_Works/PNC2022/1_Official_phase/pnc_2022_newdata_run3_with_segmentation/'+os.path.basename(filename).split(".")[0]+'ma.png', bbox_inches='tight')
        #
        # #plt.show()
        # plt.close()

        # #===================
        # # optimize alpha for different level of noisy files
        #threshold = np.percentile(ma, 50)*1.7
        ma_greaterthan_thres = np.where(ma > threshold)[0]
        window_a=[]
        window_b=[]
        for n in ma_greaterthan_thres:
            a = n
            b = n + ma_win - 1
            #
            noise_start_idx = 1 + (a ) * overlap
            noise_end_idx =  (b) * overlap + nperseg

            window_a.append(noise_start_idx)
            window_b.append(noise_end_idx)


        window_b = np.array(window_b)
        window_a = np.array(window_a)
        #for i in range(1, len(window_a)):

        x = window_a[1:len(window_a)] - window_b[0:len(window_b) - 1]
        window_b = list(window_b)
        window_a = list(window_a)
        neg_idx = np.where(x < 0)[0]

        window_a_new = np.delete(window_a, neg_idx+1)
        window_b_new = np.delete(window_b, neg_idx)
        window_a_new = window_a_new-1
        #sound_states, heartRate = pcg_segmentation(raw_pcg_norm_resamp)
        sound_states = original_sound_states

        indexes_to_remove = []
        for noise_window in range(len(window_a_new)):
            # find the previous state 4 before a_new and update a_new
            # if state 4 is not available a_new is the begining of the signal


            # find the next state 1 after b_new and update b_new
            # if state 1 is not available b_new is the end of the signal


           indexes_to_remove.extend(np.arange(window_a_new[noise_window], window_b_new[noise_window]))

        #=================================================================
        sound_states = sound_states + 1  # converting states [0,1,2,3] to [1,2,3,4]

        noise_marked_sound_states = sound_states
        noise_marked_sound_states[indexes_to_remove] = 0  # marking noise states as 0

        # get start and stop for all states
        dff_array = np.diff(noise_marked_sound_states, axis=0)
        non_zero_dff_index = np.where(dff_array[:,0] != 0)[0]

        st = np.hstack([0, non_zero_dff_index+1])  # start index of segment
        stp = np.hstack([non_zero_dff_index+1, len(noise_marked_sound_states)-1])  # end index of segment

        # converting samples to time in sec
        st_sec = st/fs
        stp_sec = stp/fs

        noise_marked_sound_states_reshaped = np.hstack((st_sec.reshape(-1,1), stp_sec.reshape(-1,1), noise_marked_sound_states[st]))
        #noise_marked_sound_states_reshaped = noise_marked_sound_states_reshaped.astype(int)

        try:
            sound_states_for_complete_cycle = remove_noisy_incomplete_cycle(noise_marked_sound_states_reshaped)

        except:
            threshold = threshold * 1.05
            sound_states_for_complete_cycle = np.empty([1,3])
            #clean_signal_ok = 0
            #continue;
        # if len(sound_states_for_complete_cycle) < 16:#8
        #     threshold = threshold * 1.05
        # else:
        #     clean_signal_ok = 1

        if (len(sound_states_for_complete_cycle) < num_of_segments_in_order):  # 8
            threshold = threshold * 1.05

        else:
            clean_signal_ok = 1

        if threshold > 50000:
            break




    #=========================================================================
    # # plot noise over pcg signal
    # complete_cycle_indexes = []
    # for idx in range(sound_states_for_complete_cycle.shape[0]):
    #     complete_cycle_indexes.extend(np.arange(sound_states_for_complete_cycle[idx,0]* fs, sound_states_for_complete_cycle[idx,1]* fs))
    #
    # complete_cycle_indexes = np.hstack(complete_cycle_indexes).astype(int)
    #
    # # plt.plot(np.arange(0, len(raw_pcg_norm_resamp)), raw_pcg_norm_resamp)
    # # plt.plot(np.arange(0, len(raw_pcg_norm_resamp))[complete_cycle_indexes], raw_pcg_norm_resamp[complete_cycle_indexes], 'ro')
    # # plt.show()
    # #
    # # plt.savefig('/home/varsha/2022_Works/PNC2022/1_Official_phase/pnc_2022_newdata_run3_with_segmentation/' +
    # #             os.path.basename(filename).split(".")[0] + 'clean.png', bbox_inches='tight')
    # #
    # # # plt.show()
    # # plt.close()
    #
    # # noise_percent = 100 * (len(raw_pcg_norm_resamp) - len(complete_cycle_indexes))/ len(raw_pcg_norm_resamp)
    # # print('noise_percent', noise_percent)


    return sound_states_for_complete_cycle


# print('A')
#
# #
#
#
# # #-----------------------------
# # # Conversion factors
# # # alpha for raw signal to spectrogram length
# # alpha = np.floor((len(current_recordings) - nperseg)/(nperseg - overlap))+1
# # # beta for spectrogram length to moving average length
# # beta = alpha - int((cardiac_cycle * (alpha/len(current_recordings)))/1)+1
#
# # gamma = alpha * beta
#
# print('A')



